<template>
	<div id="app">
		<Header />

		<div ref="navMarker"></div>
		<navbar />
		<router-view :key="$route.fullPath"></router-view>
		<button-back-to-top :back-to-top-is-visible="backToTopIsVisible" />
	</div>
</template>

<script>

import Header from "@/components/Header";
import Navbar from "@/components/Navbar";
import ButtonBackToTop from "@/components/ButtonBackToTop";
import jwtDecode from "jwt-decode";

export default {
	name: 'App',
	data: () => ({
		backToTopIsVisible: false
	}),
	components: {
		ButtonBackToTop,
		Header,
		Navbar
	},
	methods: {
		toggleButtonBackToTop () {
			this.backToTopIsVisible = window.scrollY > this.$refs.navMarker.offsetTop;
		}
	},

	mounted() {
		window.addEventListener("scroll", this.toggleButtonBackToTop);

		if (!this.isLoggedIn && localStorage.getItem("jwt")) {
			let decodedJwt = jwtDecode(localStorage.getItem("jwt"));
			if (decodedJwt) {
				this.$store.dispatch("login", {
					"jwt": localStorage.getItem("jwt"),
					"userEmail": decodedJwt["sub"],
					"userName": decodedJwt["userName"],
					"userId": decodedJwt["userId"],
					"auth": decodedJwt["roles"][0].authority
				});
			} else {
				this.$store.dispatch("logout");
			}
		}
	},

	destroyed() {
		window.removeEventListener("scroll", this.toggleButtonBackToTop);
	},
	computed: {
		isLoggedIn() {
			return this.$store.getters.isLoggedIn;
		}
	}
}
</script>

<style src="./assets/styles/main.css">
/*@import "assets/styles/main.css";*/
</style>
